Package org.optaplanner.core.impl.solver.termination

## Class BestScoreFeasibleTermination<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.solver.event.SolverLifecycleListenerAdapter<Solution_>
  - - org.optaplanner.core.impl.phase.event.PhaseLifecycleListenerAdapter<Solution_>
    - - org.optaplanner.core.impl.solver.termination.AbstractTermination<Solution_>
      - - org.optaplanner.core.impl.solver.termination.BestScoreFeasibleTermination<Solution_>

- All Implemented Interfaces:
    `EventListener`, `PhaseLifecycleListener<Solution_>`, `SolverLifecycleListener<Solution_>`, `Termination<Solution_>`

      public class BestScoreFeasibleTermination<Solution_>
      extends AbstractTermination<Solution_>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.solver.termination.AbstractTermination

      `logger`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BestScoreFeasibleTermination​(ScoreDefinition scoreDefinition, double[] timeGradientWeightFeasibleNumbers)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected double` | `calculateFeasibilityTimeGradient​(Score startScore, Score score)` |
    `double` | `calculatePhaseTimeGradient​(AbstractPhaseScope<Solution_> phaseScope)` | See `Termination.calculateSolverTimeGradient(SolverScope)`.
    `double` | `calculateSolverTimeGradient​(SolverScope<Solution_> solverScope)` | A timeGradient is a relative estimate of how long the search will continue.
    `Termination<Solution_>` | `createChildThreadTermination​(SolverScope<Solution_> solverScope, ChildThreadType childThreadType)` | Create a `Termination` for a child `Thread` of the `Solver`.
    `boolean` | `isPhaseTerminated​(AbstractPhaseScope<Solution_> phaseScope)` | Called by the `Phase` after every step and every move to determine if the search should stop.
    `boolean` | `isSolverTerminated​(SolverScope<Solution_> solverScope)` | Called by the `Solver` after every phase to determine if the search should stop.
    `protected boolean` | `isTerminated​(Score bestScore)` |
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.impl.phase.event.PhaseLifecycleListenerAdapter

      `phaseEnded, phaseStarted, stepEnded, stepStarted`

    - ### Methods inherited from class org.optaplanner.core.impl.solver.event.SolverLifecycleListenerAdapter

      `solvingEnded, solvingStarted`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.phase.event.PhaseLifecycleListener

      `phaseEnded, phaseStarted, stepEnded, stepStarted`

    - ### Methods inherited from interface org.optaplanner.core.impl.solver.event.SolverLifecycleListener

      `solvingEnded, solvingStarted`

- - ### Constructor Detail

    - #### BestScoreFeasibleTermination

          public BestScoreFeasibleTermination​(ScoreDefinition scoreDefinition,
                                              double[] timeGradientWeightFeasibleNumbers)

  - ### Method Detail

    - #### isSolverTerminated

          public boolean isSolverTerminated​(SolverScope<Solution_> solverScope)

      Description copied from interface: `Termination`
      Called by the `Solver` after every phase to determine if the search should stop.
      Parameters:
        `solverScope` - never null
      Returns:
        true if the search should terminate.

    - #### isPhaseTerminated

          public boolean isPhaseTerminated​(AbstractPhaseScope<Solution_> phaseScope)

      Description copied from interface: `Termination`
      Called by the `Phase` after every step and every move to determine if the search should stop.
      Parameters:
        `phaseScope` - never null
      Returns:
        true if the search should terminate.

    - #### isTerminated

          protected boolean isTerminated​(Score bestScore)

    - #### calculateSolverTimeGradient

          public double calculateSolverTimeGradient​(SolverScope<Solution_> solverScope)

      Description copied from interface: `Termination`
      A timeGradient is a relative estimate of how long the search will continue.

      Clients that use a timeGradient should cache it at the start of a single step because some implementations are not time-stable.

      If a timeGradient cannot be calculated, it should return -1.0. Several implementations (such a `SimulatedAnnealingAcceptor`) require a correctly implemented timeGradient.

      A Termination's timeGradient can be requested after they are terminated, so implementations should be careful not to return a timeGradient above 1.0.

      Parameters:
        `solverScope` - never null
      Returns:
        timeGradient t for which `0.0 <= t <= 1.0 or -1.0` when it is not supported. At the start of a solver t is 0.0 and at the end t would be 1.0.

    - #### calculatePhaseTimeGradient

          public double calculatePhaseTimeGradient​(AbstractPhaseScope<Solution_> phaseScope)

      Description copied from interface: `Termination`
      See `Termination.calculateSolverTimeGradient(SolverScope)`.
      Parameters:
        `phaseScope` - never null
      Returns:
        timeGradient t for which `0.0 <= t <= 1.0 or -1.0` when it is not supported. At the start of a phase t is 0.0 and at the end t would be 1.0.

    - #### calculateFeasibilityTimeGradient

          protected double calculateFeasibilityTimeGradient​(Score startScore,
                                                            Score score)

    - #### createChildThreadTermination

          public Termination<Solution_> createChildThreadTermination​(SolverScope<Solution_> solverScope,
                                                                     ChildThreadType childThreadType)

      Description copied from interface: `Termination`
      Create a `Termination` for a child `Thread` of the `Solver`.
      Specified by:
        `createChildThreadTermination` in interface `Termination<Solution_>`
      Overrides:
        `createChildThreadTermination` in class `AbstractTermination<Solution_>`
      Parameters:
        `solverScope` - never null
        `childThreadType` - never null
      Returns:
        not null

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`